Imports Monitor = System.Threading.Monitor
Imports Thread = System.Threading.Thread
Imports ThreadInterruptedException = System.Threading.ThreadInterruptedException

Public Class Semaphore
    Protected N As Integer

    Public Sub New()
        Me.N = 0
    End Sub

    Public Sub New(ByVal N As Integer)
        Me.N = N
    End Sub


    Public Sub Decrement()
        SyncLock Me
            While (N <= 0)
                Try
                    Monitor.Wait(Me)
                Catch ex As ThreadInterruptedException
                End Try
            End While
            N = N - 1
        End SyncLock
    End Sub

    Public Sub Increment()
        SyncLock Me
            N = N + 1
            Monitor.Pulse(Me)
        End SyncLock
    End Sub
End Class
